// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

/**
 * <pre>
 * Grid connect mode kind
 * </pre>
 *
 * Protobuf type {@code commonmodule.RampRate}
 */
public final class RampRate extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:commonmodule.RampRate)
    RampRateOrBuilder {
private static final long serialVersionUID = 0L;
  // Use RampRate.newBuilder() to construct.
  private RampRate(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private RampRate() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new RampRate();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_RampRate_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_RampRate_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.commonmodule.RampRate.class, openfmb.commonmodule.RampRate.Builder.class);
  }

  public static final int NEGATIVEREACTIVEPOWERKVARPERMIN_FIELD_NUMBER = 1;
  private com.google.protobuf.FloatValue negativeReactivePowerKVArPerMin_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue negativeReactivePowerKVArPerMin = 1;</code>
   * @return Whether the negativeReactivePowerKVArPerMin field is set.
   */
  @java.lang.Override
  public boolean hasNegativeReactivePowerKVArPerMin() {
    return negativeReactivePowerKVArPerMin_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue negativeReactivePowerKVArPerMin = 1;</code>
   * @return The negativeReactivePowerKVArPerMin.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getNegativeReactivePowerKVArPerMin() {
    return negativeReactivePowerKVArPerMin_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : negativeReactivePowerKVArPerMin_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue negativeReactivePowerKVArPerMin = 1;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getNegativeReactivePowerKVArPerMinOrBuilder() {
    return negativeReactivePowerKVArPerMin_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : negativeReactivePowerKVArPerMin_;
  }

  public static final int NEGATIVEREALPOWERKWPERMIN_FIELD_NUMBER = 2;
  private com.google.protobuf.FloatValue negativeRealPowerKWPerMin_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue negativeRealPowerKWPerMin = 2;</code>
   * @return Whether the negativeRealPowerKWPerMin field is set.
   */
  @java.lang.Override
  public boolean hasNegativeRealPowerKWPerMin() {
    return negativeRealPowerKWPerMin_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue negativeRealPowerKWPerMin = 2;</code>
   * @return The negativeRealPowerKWPerMin.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getNegativeRealPowerKWPerMin() {
    return negativeRealPowerKWPerMin_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : negativeRealPowerKWPerMin_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue negativeRealPowerKWPerMin = 2;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getNegativeRealPowerKWPerMinOrBuilder() {
    return negativeRealPowerKWPerMin_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : negativeRealPowerKWPerMin_;
  }

  public static final int POSITIVEREACTIVEPOWERKVARPERMIN_FIELD_NUMBER = 3;
  private com.google.protobuf.FloatValue positiveReactivePowerKVArPerMin_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue positiveReactivePowerKVArPerMin = 3;</code>
   * @return Whether the positiveReactivePowerKVArPerMin field is set.
   */
  @java.lang.Override
  public boolean hasPositiveReactivePowerKVArPerMin() {
    return positiveReactivePowerKVArPerMin_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue positiveReactivePowerKVArPerMin = 3;</code>
   * @return The positiveReactivePowerKVArPerMin.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getPositiveReactivePowerKVArPerMin() {
    return positiveReactivePowerKVArPerMin_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : positiveReactivePowerKVArPerMin_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue positiveReactivePowerKVArPerMin = 3;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getPositiveReactivePowerKVArPerMinOrBuilder() {
    return positiveReactivePowerKVArPerMin_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : positiveReactivePowerKVArPerMin_;
  }

  public static final int POSITIVEREALPOWERKWPERMIN_FIELD_NUMBER = 4;
  private com.google.protobuf.FloatValue positiveRealPowerKWPerMin_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue positiveRealPowerKWPerMin = 4;</code>
   * @return Whether the positiveRealPowerKWPerMin field is set.
   */
  @java.lang.Override
  public boolean hasPositiveRealPowerKWPerMin() {
    return positiveRealPowerKWPerMin_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue positiveRealPowerKWPerMin = 4;</code>
   * @return The positiveRealPowerKWPerMin.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getPositiveRealPowerKWPerMin() {
    return positiveRealPowerKWPerMin_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : positiveRealPowerKWPerMin_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue positiveRealPowerKWPerMin = 4;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getPositiveRealPowerKWPerMinOrBuilder() {
    return positiveRealPowerKWPerMin_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : positiveRealPowerKWPerMin_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (negativeReactivePowerKVArPerMin_ != null) {
      output.writeMessage(1, getNegativeReactivePowerKVArPerMin());
    }
    if (negativeRealPowerKWPerMin_ != null) {
      output.writeMessage(2, getNegativeRealPowerKWPerMin());
    }
    if (positiveReactivePowerKVArPerMin_ != null) {
      output.writeMessage(3, getPositiveReactivePowerKVArPerMin());
    }
    if (positiveRealPowerKWPerMin_ != null) {
      output.writeMessage(4, getPositiveRealPowerKWPerMin());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (negativeReactivePowerKVArPerMin_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getNegativeReactivePowerKVArPerMin());
    }
    if (negativeRealPowerKWPerMin_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getNegativeRealPowerKWPerMin());
    }
    if (positiveReactivePowerKVArPerMin_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getPositiveReactivePowerKVArPerMin());
    }
    if (positiveRealPowerKWPerMin_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getPositiveRealPowerKWPerMin());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.commonmodule.RampRate)) {
      return super.equals(obj);
    }
    openfmb.commonmodule.RampRate other = (openfmb.commonmodule.RampRate) obj;

    if (hasNegativeReactivePowerKVArPerMin() != other.hasNegativeReactivePowerKVArPerMin()) return false;
    if (hasNegativeReactivePowerKVArPerMin()) {
      if (!getNegativeReactivePowerKVArPerMin()
          .equals(other.getNegativeReactivePowerKVArPerMin())) return false;
    }
    if (hasNegativeRealPowerKWPerMin() != other.hasNegativeRealPowerKWPerMin()) return false;
    if (hasNegativeRealPowerKWPerMin()) {
      if (!getNegativeRealPowerKWPerMin()
          .equals(other.getNegativeRealPowerKWPerMin())) return false;
    }
    if (hasPositiveReactivePowerKVArPerMin() != other.hasPositiveReactivePowerKVArPerMin()) return false;
    if (hasPositiveReactivePowerKVArPerMin()) {
      if (!getPositiveReactivePowerKVArPerMin()
          .equals(other.getPositiveReactivePowerKVArPerMin())) return false;
    }
    if (hasPositiveRealPowerKWPerMin() != other.hasPositiveRealPowerKWPerMin()) return false;
    if (hasPositiveRealPowerKWPerMin()) {
      if (!getPositiveRealPowerKWPerMin()
          .equals(other.getPositiveRealPowerKWPerMin())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasNegativeReactivePowerKVArPerMin()) {
      hash = (37 * hash) + NEGATIVEREACTIVEPOWERKVARPERMIN_FIELD_NUMBER;
      hash = (53 * hash) + getNegativeReactivePowerKVArPerMin().hashCode();
    }
    if (hasNegativeRealPowerKWPerMin()) {
      hash = (37 * hash) + NEGATIVEREALPOWERKWPERMIN_FIELD_NUMBER;
      hash = (53 * hash) + getNegativeRealPowerKWPerMin().hashCode();
    }
    if (hasPositiveReactivePowerKVArPerMin()) {
      hash = (37 * hash) + POSITIVEREACTIVEPOWERKVARPERMIN_FIELD_NUMBER;
      hash = (53 * hash) + getPositiveReactivePowerKVArPerMin().hashCode();
    }
    if (hasPositiveRealPowerKWPerMin()) {
      hash = (37 * hash) + POSITIVEREALPOWERKWPERMIN_FIELD_NUMBER;
      hash = (53 * hash) + getPositiveRealPowerKWPerMin().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.commonmodule.RampRate parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.RampRate parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.RampRate parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.RampRate parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.RampRate parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.RampRate parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.RampRate parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.RampRate parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.RampRate parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.RampRate parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.RampRate parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.RampRate parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.commonmodule.RampRate prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Grid connect mode kind
   * </pre>
   *
   * Protobuf type {@code commonmodule.RampRate}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:commonmodule.RampRate)
      openfmb.commonmodule.RampRateOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_RampRate_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_RampRate_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.commonmodule.RampRate.class, openfmb.commonmodule.RampRate.Builder.class);
    }

    // Construct using openfmb.commonmodule.RampRate.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      negativeReactivePowerKVArPerMin_ = null;
      if (negativeReactivePowerKVArPerMinBuilder_ != null) {
        negativeReactivePowerKVArPerMinBuilder_.dispose();
        negativeReactivePowerKVArPerMinBuilder_ = null;
      }
      negativeRealPowerKWPerMin_ = null;
      if (negativeRealPowerKWPerMinBuilder_ != null) {
        negativeRealPowerKWPerMinBuilder_.dispose();
        negativeRealPowerKWPerMinBuilder_ = null;
      }
      positiveReactivePowerKVArPerMin_ = null;
      if (positiveReactivePowerKVArPerMinBuilder_ != null) {
        positiveReactivePowerKVArPerMinBuilder_.dispose();
        positiveReactivePowerKVArPerMinBuilder_ = null;
      }
      positiveRealPowerKWPerMin_ = null;
      if (positiveRealPowerKWPerMinBuilder_ != null) {
        positiveRealPowerKWPerMinBuilder_.dispose();
        positiveRealPowerKWPerMinBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_RampRate_descriptor;
    }

    @java.lang.Override
    public openfmb.commonmodule.RampRate getDefaultInstanceForType() {
      return openfmb.commonmodule.RampRate.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.commonmodule.RampRate build() {
      openfmb.commonmodule.RampRate result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.commonmodule.RampRate buildPartial() {
      openfmb.commonmodule.RampRate result = new openfmb.commonmodule.RampRate(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.commonmodule.RampRate result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.negativeReactivePowerKVArPerMin_ = negativeReactivePowerKVArPerMinBuilder_ == null
            ? negativeReactivePowerKVArPerMin_
            : negativeReactivePowerKVArPerMinBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.negativeRealPowerKWPerMin_ = negativeRealPowerKWPerMinBuilder_ == null
            ? negativeRealPowerKWPerMin_
            : negativeRealPowerKWPerMinBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.positiveReactivePowerKVArPerMin_ = positiveReactivePowerKVArPerMinBuilder_ == null
            ? positiveReactivePowerKVArPerMin_
            : positiveReactivePowerKVArPerMinBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.positiveRealPowerKWPerMin_ = positiveRealPowerKWPerMinBuilder_ == null
            ? positiveRealPowerKWPerMin_
            : positiveRealPowerKWPerMinBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.commonmodule.RampRate) {
        return mergeFrom((openfmb.commonmodule.RampRate)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.commonmodule.RampRate other) {
      if (other == openfmb.commonmodule.RampRate.getDefaultInstance()) return this;
      if (other.hasNegativeReactivePowerKVArPerMin()) {
        mergeNegativeReactivePowerKVArPerMin(other.getNegativeReactivePowerKVArPerMin());
      }
      if (other.hasNegativeRealPowerKWPerMin()) {
        mergeNegativeRealPowerKWPerMin(other.getNegativeRealPowerKWPerMin());
      }
      if (other.hasPositiveReactivePowerKVArPerMin()) {
        mergePositiveReactivePowerKVArPerMin(other.getPositiveReactivePowerKVArPerMin());
      }
      if (other.hasPositiveRealPowerKWPerMin()) {
        mergePositiveRealPowerKWPerMin(other.getPositiveRealPowerKWPerMin());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getNegativeReactivePowerKVArPerMinFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getNegativeRealPowerKWPerMinFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getPositiveReactivePowerKVArPerMinFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            case 34: {
              input.readMessage(
                  getPositiveRealPowerKWPerMinFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000008;
              break;
            } // case 34
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private com.google.protobuf.FloatValue negativeReactivePowerKVArPerMin_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> negativeReactivePowerKVArPerMinBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue negativeReactivePowerKVArPerMin = 1;</code>
     * @return Whether the negativeReactivePowerKVArPerMin field is set.
     */
    public boolean hasNegativeReactivePowerKVArPerMin() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue negativeReactivePowerKVArPerMin = 1;</code>
     * @return The negativeReactivePowerKVArPerMin.
     */
    public com.google.protobuf.FloatValue getNegativeReactivePowerKVArPerMin() {
      if (negativeReactivePowerKVArPerMinBuilder_ == null) {
        return negativeReactivePowerKVArPerMin_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : negativeReactivePowerKVArPerMin_;
      } else {
        return negativeReactivePowerKVArPerMinBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue negativeReactivePowerKVArPerMin = 1;</code>
     */
    public Builder setNegativeReactivePowerKVArPerMin(com.google.protobuf.FloatValue value) {
      if (negativeReactivePowerKVArPerMinBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        negativeReactivePowerKVArPerMin_ = value;
      } else {
        negativeReactivePowerKVArPerMinBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue negativeReactivePowerKVArPerMin = 1;</code>
     */
    public Builder setNegativeReactivePowerKVArPerMin(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (negativeReactivePowerKVArPerMinBuilder_ == null) {
        negativeReactivePowerKVArPerMin_ = builderForValue.build();
      } else {
        negativeReactivePowerKVArPerMinBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue negativeReactivePowerKVArPerMin = 1;</code>
     */
    public Builder mergeNegativeReactivePowerKVArPerMin(com.google.protobuf.FloatValue value) {
      if (negativeReactivePowerKVArPerMinBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          negativeReactivePowerKVArPerMin_ != null &&
          negativeReactivePowerKVArPerMin_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getNegativeReactivePowerKVArPerMinBuilder().mergeFrom(value);
        } else {
          negativeReactivePowerKVArPerMin_ = value;
        }
      } else {
        negativeReactivePowerKVArPerMinBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue negativeReactivePowerKVArPerMin = 1;</code>
     */
    public Builder clearNegativeReactivePowerKVArPerMin() {
      bitField0_ = (bitField0_ & ~0x00000001);
      negativeReactivePowerKVArPerMin_ = null;
      if (negativeReactivePowerKVArPerMinBuilder_ != null) {
        negativeReactivePowerKVArPerMinBuilder_.dispose();
        negativeReactivePowerKVArPerMinBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue negativeReactivePowerKVArPerMin = 1;</code>
     */
    public com.google.protobuf.FloatValue.Builder getNegativeReactivePowerKVArPerMinBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getNegativeReactivePowerKVArPerMinFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue negativeReactivePowerKVArPerMin = 1;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getNegativeReactivePowerKVArPerMinOrBuilder() {
      if (negativeReactivePowerKVArPerMinBuilder_ != null) {
        return negativeReactivePowerKVArPerMinBuilder_.getMessageOrBuilder();
      } else {
        return negativeReactivePowerKVArPerMin_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : negativeReactivePowerKVArPerMin_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue negativeReactivePowerKVArPerMin = 1;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getNegativeReactivePowerKVArPerMinFieldBuilder() {
      if (negativeReactivePowerKVArPerMinBuilder_ == null) {
        negativeReactivePowerKVArPerMinBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getNegativeReactivePowerKVArPerMin(),
                getParentForChildren(),
                isClean());
        negativeReactivePowerKVArPerMin_ = null;
      }
      return negativeReactivePowerKVArPerMinBuilder_;
    }

    private com.google.protobuf.FloatValue negativeRealPowerKWPerMin_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> negativeRealPowerKWPerMinBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue negativeRealPowerKWPerMin = 2;</code>
     * @return Whether the negativeRealPowerKWPerMin field is set.
     */
    public boolean hasNegativeRealPowerKWPerMin() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue negativeRealPowerKWPerMin = 2;</code>
     * @return The negativeRealPowerKWPerMin.
     */
    public com.google.protobuf.FloatValue getNegativeRealPowerKWPerMin() {
      if (negativeRealPowerKWPerMinBuilder_ == null) {
        return negativeRealPowerKWPerMin_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : negativeRealPowerKWPerMin_;
      } else {
        return negativeRealPowerKWPerMinBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue negativeRealPowerKWPerMin = 2;</code>
     */
    public Builder setNegativeRealPowerKWPerMin(com.google.protobuf.FloatValue value) {
      if (negativeRealPowerKWPerMinBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        negativeRealPowerKWPerMin_ = value;
      } else {
        negativeRealPowerKWPerMinBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue negativeRealPowerKWPerMin = 2;</code>
     */
    public Builder setNegativeRealPowerKWPerMin(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (negativeRealPowerKWPerMinBuilder_ == null) {
        negativeRealPowerKWPerMin_ = builderForValue.build();
      } else {
        negativeRealPowerKWPerMinBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue negativeRealPowerKWPerMin = 2;</code>
     */
    public Builder mergeNegativeRealPowerKWPerMin(com.google.protobuf.FloatValue value) {
      if (negativeRealPowerKWPerMinBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          negativeRealPowerKWPerMin_ != null &&
          negativeRealPowerKWPerMin_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getNegativeRealPowerKWPerMinBuilder().mergeFrom(value);
        } else {
          negativeRealPowerKWPerMin_ = value;
        }
      } else {
        negativeRealPowerKWPerMinBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue negativeRealPowerKWPerMin = 2;</code>
     */
    public Builder clearNegativeRealPowerKWPerMin() {
      bitField0_ = (bitField0_ & ~0x00000002);
      negativeRealPowerKWPerMin_ = null;
      if (negativeRealPowerKWPerMinBuilder_ != null) {
        negativeRealPowerKWPerMinBuilder_.dispose();
        negativeRealPowerKWPerMinBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue negativeRealPowerKWPerMin = 2;</code>
     */
    public com.google.protobuf.FloatValue.Builder getNegativeRealPowerKWPerMinBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getNegativeRealPowerKWPerMinFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue negativeRealPowerKWPerMin = 2;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getNegativeRealPowerKWPerMinOrBuilder() {
      if (negativeRealPowerKWPerMinBuilder_ != null) {
        return negativeRealPowerKWPerMinBuilder_.getMessageOrBuilder();
      } else {
        return negativeRealPowerKWPerMin_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : negativeRealPowerKWPerMin_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue negativeRealPowerKWPerMin = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getNegativeRealPowerKWPerMinFieldBuilder() {
      if (negativeRealPowerKWPerMinBuilder_ == null) {
        negativeRealPowerKWPerMinBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getNegativeRealPowerKWPerMin(),
                getParentForChildren(),
                isClean());
        negativeRealPowerKWPerMin_ = null;
      }
      return negativeRealPowerKWPerMinBuilder_;
    }

    private com.google.protobuf.FloatValue positiveReactivePowerKVArPerMin_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> positiveReactivePowerKVArPerMinBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue positiveReactivePowerKVArPerMin = 3;</code>
     * @return Whether the positiveReactivePowerKVArPerMin field is set.
     */
    public boolean hasPositiveReactivePowerKVArPerMin() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue positiveReactivePowerKVArPerMin = 3;</code>
     * @return The positiveReactivePowerKVArPerMin.
     */
    public com.google.protobuf.FloatValue getPositiveReactivePowerKVArPerMin() {
      if (positiveReactivePowerKVArPerMinBuilder_ == null) {
        return positiveReactivePowerKVArPerMin_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : positiveReactivePowerKVArPerMin_;
      } else {
        return positiveReactivePowerKVArPerMinBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue positiveReactivePowerKVArPerMin = 3;</code>
     */
    public Builder setPositiveReactivePowerKVArPerMin(com.google.protobuf.FloatValue value) {
      if (positiveReactivePowerKVArPerMinBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        positiveReactivePowerKVArPerMin_ = value;
      } else {
        positiveReactivePowerKVArPerMinBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue positiveReactivePowerKVArPerMin = 3;</code>
     */
    public Builder setPositiveReactivePowerKVArPerMin(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (positiveReactivePowerKVArPerMinBuilder_ == null) {
        positiveReactivePowerKVArPerMin_ = builderForValue.build();
      } else {
        positiveReactivePowerKVArPerMinBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue positiveReactivePowerKVArPerMin = 3;</code>
     */
    public Builder mergePositiveReactivePowerKVArPerMin(com.google.protobuf.FloatValue value) {
      if (positiveReactivePowerKVArPerMinBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          positiveReactivePowerKVArPerMin_ != null &&
          positiveReactivePowerKVArPerMin_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getPositiveReactivePowerKVArPerMinBuilder().mergeFrom(value);
        } else {
          positiveReactivePowerKVArPerMin_ = value;
        }
      } else {
        positiveReactivePowerKVArPerMinBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue positiveReactivePowerKVArPerMin = 3;</code>
     */
    public Builder clearPositiveReactivePowerKVArPerMin() {
      bitField0_ = (bitField0_ & ~0x00000004);
      positiveReactivePowerKVArPerMin_ = null;
      if (positiveReactivePowerKVArPerMinBuilder_ != null) {
        positiveReactivePowerKVArPerMinBuilder_.dispose();
        positiveReactivePowerKVArPerMinBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue positiveReactivePowerKVArPerMin = 3;</code>
     */
    public com.google.protobuf.FloatValue.Builder getPositiveReactivePowerKVArPerMinBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getPositiveReactivePowerKVArPerMinFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue positiveReactivePowerKVArPerMin = 3;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getPositiveReactivePowerKVArPerMinOrBuilder() {
      if (positiveReactivePowerKVArPerMinBuilder_ != null) {
        return positiveReactivePowerKVArPerMinBuilder_.getMessageOrBuilder();
      } else {
        return positiveReactivePowerKVArPerMin_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : positiveReactivePowerKVArPerMin_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue positiveReactivePowerKVArPerMin = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getPositiveReactivePowerKVArPerMinFieldBuilder() {
      if (positiveReactivePowerKVArPerMinBuilder_ == null) {
        positiveReactivePowerKVArPerMinBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getPositiveReactivePowerKVArPerMin(),
                getParentForChildren(),
                isClean());
        positiveReactivePowerKVArPerMin_ = null;
      }
      return positiveReactivePowerKVArPerMinBuilder_;
    }

    private com.google.protobuf.FloatValue positiveRealPowerKWPerMin_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> positiveRealPowerKWPerMinBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue positiveRealPowerKWPerMin = 4;</code>
     * @return Whether the positiveRealPowerKWPerMin field is set.
     */
    public boolean hasPositiveRealPowerKWPerMin() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue positiveRealPowerKWPerMin = 4;</code>
     * @return The positiveRealPowerKWPerMin.
     */
    public com.google.protobuf.FloatValue getPositiveRealPowerKWPerMin() {
      if (positiveRealPowerKWPerMinBuilder_ == null) {
        return positiveRealPowerKWPerMin_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : positiveRealPowerKWPerMin_;
      } else {
        return positiveRealPowerKWPerMinBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue positiveRealPowerKWPerMin = 4;</code>
     */
    public Builder setPositiveRealPowerKWPerMin(com.google.protobuf.FloatValue value) {
      if (positiveRealPowerKWPerMinBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        positiveRealPowerKWPerMin_ = value;
      } else {
        positiveRealPowerKWPerMinBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue positiveRealPowerKWPerMin = 4;</code>
     */
    public Builder setPositiveRealPowerKWPerMin(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (positiveRealPowerKWPerMinBuilder_ == null) {
        positiveRealPowerKWPerMin_ = builderForValue.build();
      } else {
        positiveRealPowerKWPerMinBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue positiveRealPowerKWPerMin = 4;</code>
     */
    public Builder mergePositiveRealPowerKWPerMin(com.google.protobuf.FloatValue value) {
      if (positiveRealPowerKWPerMinBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0) &&
          positiveRealPowerKWPerMin_ != null &&
          positiveRealPowerKWPerMin_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getPositiveRealPowerKWPerMinBuilder().mergeFrom(value);
        } else {
          positiveRealPowerKWPerMin_ = value;
        }
      } else {
        positiveRealPowerKWPerMinBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue positiveRealPowerKWPerMin = 4;</code>
     */
    public Builder clearPositiveRealPowerKWPerMin() {
      bitField0_ = (bitField0_ & ~0x00000008);
      positiveRealPowerKWPerMin_ = null;
      if (positiveRealPowerKWPerMinBuilder_ != null) {
        positiveRealPowerKWPerMinBuilder_.dispose();
        positiveRealPowerKWPerMinBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue positiveRealPowerKWPerMin = 4;</code>
     */
    public com.google.protobuf.FloatValue.Builder getPositiveRealPowerKWPerMinBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getPositiveRealPowerKWPerMinFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue positiveRealPowerKWPerMin = 4;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getPositiveRealPowerKWPerMinOrBuilder() {
      if (positiveRealPowerKWPerMinBuilder_ != null) {
        return positiveRealPowerKWPerMinBuilder_.getMessageOrBuilder();
      } else {
        return positiveRealPowerKWPerMin_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : positiveRealPowerKWPerMin_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue positiveRealPowerKWPerMin = 4;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getPositiveRealPowerKWPerMinFieldBuilder() {
      if (positiveRealPowerKWPerMinBuilder_ == null) {
        positiveRealPowerKWPerMinBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getPositiveRealPowerKWPerMin(),
                getParentForChildren(),
                isClean());
        positiveRealPowerKWPerMin_ = null;
      }
      return positiveRealPowerKWPerMinBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:commonmodule.RampRate)
  }

  // @@protoc_insertion_point(class_scope:commonmodule.RampRate)
  private static final openfmb.commonmodule.RampRate DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.commonmodule.RampRate();
  }

  public static openfmb.commonmodule.RampRate getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<RampRate>
      PARSER = new com.google.protobuf.AbstractParser<RampRate>() {
    @java.lang.Override
    public RampRate parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<RampRate> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<RampRate> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.commonmodule.RampRate getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

